/************************************************************************************
 *: ZD-20U-9
 *: 1.2
 * : 16.04.2018 11:58:58
 * :  .
 *: 
 *:   USB 
 *: ATTINY45-20SU
 * RC : 8000000 
 FuseHB=DC:
			RSTDISBL=1;     
			DWEN=1;    debugWire
			SPIEN=0;     SPI
			WDTON=1;   
			EESAVE=1;   EEPROM 
			BODLEVEL2-0=101;   BOD 2,7 
			
FuseLB=42:		
			CKDIV8=0;     1 
			CKOUT=1;     
			SUT1-0=00;      BOD
			CKSEL3-0=0010;  RC- 8 

Fuse Extended byte=FF:
			SELFPRGEN=1;  
			
 ******************************************************************************************/ 

#include <avr/io.h> // 
#include <avr/interrupt.h>
#include <avr/sfr_defs.h>
#include "Basdef.h"
#include "Keyscan.h"
#include "Forctime.h"
#include "Senscan.h"

#define STAT_TIM 3 //   
#define OUT_LED PORTB //   
#define BIT_LED PB0 //   
#define CONT_LED PINB //   
#define BIT_CONT PINB0 //   

volatile struct //  
	{
	bit iniforc:1; //   
	bit highforc:1; //    
	bit pressbut:1; //    
	bit lowpower:1; //   
	bit inirej:1; //    
	bit forcpress:1; //     
	bit forcsens:1; //     
	}indx={0,0,0,0,0,0,0}; // 

struct // 
	{
	byte countrej; // 
	word countime; //  
	word countwait; // 
	}base={1,0,0}; // 

int main(void)
	{
	byte base_countrej=0; //    
	byte base_diffrej=0; //    
	byte base_dablrej=0; //       
	word base_timeindled=0; //     
	DDRB=17; //PB0,PB4 ,  , PB1    
	PORTB=3; //  PB0 .1,   PB4 .0
	OCR0A=125; //    0
	TCCR0A=2; //   0   
	TCCR0B=2; //  0  CLK/8 (125 )
	OCR1B=64; //    1
	GTCCR=96; //   B    
	TCCR1=3; //  1  CLK/4,   1 
	SetBit(TIMSK,OCIE0A); //    TCNT0  OCR0A
	sei(); //  

	while (1) 
		{
		if(indx.iniforc==1) //   
			{
			if((SNS_Scan()==1)&&(indx.lowpower==0)&&(base.countrej>0)) //        
				{
				if((indx.forcsens==0)&&(indx.inirej==1)) indx.forcsens=1; //   
				base_dablrej=base.countrej; //  
				base.countrej=0; //      
				indx.lowpower=1; //   
				}
			else if((SNS_Scan()==0)&&(indx.lowpower==1)) //       
				{
				base_diffrej=base_dablrej; //   
				base.countrej=base_dablrej; //  
				indx.lowpower=0; //   
				}
			if(indx.lowpower==0) //    
				{
				if(indx.pressbut==0) //     
					{
					if(KEY_Scan()==1) //     
						{
						if((indx.forcpress==0)&&(indx.inirej==1)) //    
							{
							base_dablrej=base.countrej; //  
							indx.forcpress=1; //   
							}
						indx.pressbut=1; //   
						base.countwait=0; //  
						}
					}
				else //     
					{
					base.countrej++; //  
					if(base.countrej>3) base.countrej=0; //       
					indx.pressbut=0; //   
					}
				}
			if(base.countrej!=base_countrej) //    
				{
				switch(base.countrej) //    
					{
					case 0: OCR1B=64; //    1/4 
							break;
					case 1: OCR1B=128; //    1/2 
							break;
					case 2: OCR1B=192; //    3/4 
							break;
					case 3: OCR1B=255; //     
					}
				base_countrej=base.countrej; //    
				if(indx.inirej==0) indx.inirej=1; //      
				SNS_Restime(); //   
				}
			if((indx.forcpress==1)&&(base.countwait>2000)) //          2 
				{
				if((base.countrej>base_dablrej)&&(base.countrej<3)) //         
					{
					base_diffrej=base.countrej-base_dablrej; //  
					indx.highforc=1; //    
					}
				else base_diffrej=0; //        
				indx.forcpress=0; //      
				}
			else if((indx.forcsens==1)&&(indx.lowpower==0)) //       
				{
				if(base.countrej<3) indx.highforc=1; //          
				else base_diffrej=0; //       
				indx.forcsens=0; //      
				}
			if((indx.highforc==1)&&(FORC_Time(base_diffrej+STAT_TIM)==1)) //     
				{
				base_diffrej=0; //   
				indx.highforc=0; //  
				}
			}
		else //     
			{
			if(FORC_Time(15)==1) //   15 
				{
				SNS_Restime(); //   
				indx.iniforc=1; //   
				}
			}
		if((indx.iniforc==0)||(base.countrej==3)) //       
			{
			if(bit_is_set(CONT_LED,BIT_CONT)) ClearBit(OUT_LED,BIT_LED); //    
			}
		else //   
			{
			switch(base.countrej) //  
				{
				case 0: base_timeindled=200; //   200     1800   1/4 
						break;
				case 1: base_timeindled=1000; //   1     1   1/2 
						break;
				case 2: base_timeindled=1800; //   1800     200   3/4 
						break;
				case 3: asm("nop");
				}
			if((base.countime<base_timeindled)&&(bit_is_set(CONT_LED,BIT_CONT))) ClearBit(OUT_LED,BIT_LED); //    
			else if((base.countime>=base_timeindled)&&(base.countime<2000)) SetBit(OUT_LED,BIT_LED); //    
			else if(base.countime>=2000) base.countime=0; //    2 
			}
		}
	}

ISR(TIM0_COMPA_vect) //   TCNT0  OCR0A 0
	{
	base.countime++; //    1 
	base.countwait++; 
	FORC_Inctime();
	KEY_Inctime();
	SNS_Inctime();
	}


